# JSON Services Framework
```
        _/                _/_/
             _/_/_/    _/
      _/  _/_/      _/_/_/_/
     _/      _/_/    _/
    _/  _/_/_/      _/
   _/
_/
```

# Purpose
This repo provides three key libraries built on a common core framework (jsf_core).  A common application JSON api is present to applications consisting of only two functions (`init` and `execute`).

# Libraries

## jsf_core
The core JSON Services Framework library provides a "service tree" abstraction.  The upper level interface is generic and simple, while the lower level interface allows custom complex backends providing any functionality.  The nodes in the services tree can be any combination of static and dynamic behaviour.

### Upper API

The core (upper) interface is described in the jsf_* header files, but they are all similar (just differ in namespace).

```c++
void        init(bool Demo = false);
std::string execute(const std::string& Request);
```

### Lower API

The lower level API provides services for the backend libraries to construct the service trees.  This interface is described in [jsf_int.h](https://github.com/Xilinx-Projects/ma35_ddbi/blob/develop/lib/jsf_core/include/jsf_int.h)

## Service Libraries
* jsf_mamgmt - support library for mamgmt functionality
* jsf_xrm - support library for XRM
* jsf_mautil - support library mautil

# Test (Command Line) Applications

Simple command line applications are automatically built that allow command line access to the service trees for the three service libraries.  These applications live in the `testapps` directory (constructed from a template).  Any command that an application could issue to the service tree can be constructed from a command line.

The first argument to the test applications is the path to the service node and a second (optional) argument describes the (optional) parameters.

# Python Wrappers

All application libraries have full python support.  This is done automatically.  The templated build is in the `python` subdirectory.