/**
 * Copyright (C) 2022 Xilinx, Inc
 * Copyright (C) 2022 Advanced Micro Devices, Inc. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"). You may
 * not use this file except in compliance with the License. A copy of the
 * License is located at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

#pragma once

// Please keep eternal include file dependencies to a minimum
#include "Report.h"

class ReportErrorCnt : public Report {
private:
  bool m_is_user;

public:
  ReportErrorCnt() : Report("error-cnt", "Device error counter information", true /*device required*/){/*empty*/};

  // Child methods that need to be implemented
public:
  virtual void getPropertyTree(const std::shared_ptr<MA35Device> dev, boost::property_tree::ptree& pt) const override;
  virtual void writeReport(const boost::property_tree::ptree& pt, std::ostream& output) const override;
};
